"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PackageConfigHelper;
(function (PackageConfigHelper) {
    function getPackage(config, importPath) {
        if (!hasPackage(config, importPath)) {
            throw new Error("config does not have a PackageFolder for importPath '" + importPath + "'");
        }
        var packages = config.checkImportsBetweenPackages.packages.filter(function (pkg) { return pkg.importPath === importPath; });
        if (packages.length === 1) {
            return packages[0];
        }
        if (packages.length > 1) {
            throw new Error("config has multiple PackageFolder's for importPath '" + importPath + "'");
        }
        throw new Error("config does not have a PackageFolder for importPath '" + importPath + "'");
    }
    PackageConfigHelper.getPackage = getPackage;
    function hasPackage(config, importPath) {
        return config.checkImportsBetweenPackages.packages.some(function (pkg) { return pkg.importPath === importPath; });
    }
    PackageConfigHelper.hasPackage = hasPackage;
})(PackageConfigHelper = exports.PackageConfigHelper || (exports.PackageConfigHelper = {}));
